var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { SubStateObserverSlimmer } from '../../../../../helpers/slimmers/sub-state/sub-state-observer-slimmer';
import { MapToComponentField } from 'vega-slimmer/core';
/**
 * Controller for the table row states
 */
export class VegaTableCellStateController extends SubStateObserverSlimmer {
  // eslint-disable-next-line jsdoc/require-jsdoc
  constructor() {
    super({
      parent: 'vega-table',
      subStates: [
        {
          subStateName: 'density',
          parentStateName: 'density',
        },
        {
          subStateName: 'columnDivider',
          parentStateName: 'columnDivider',
          // eslint-disable-next-line jsdoc/require-jsdoc
          callback: (columnDivider) => {
            const parent = this.host.parentElement;
            if (parent) {
              const lastCell = parent.querySelector('vega-table-cell:last-of-type');
              this.columnDivider = columnDivider && lastCell !== this.host;
            }
          },
        },
        {
          subStateName: 'clickable',
          parentStateName: 'rowClickable',
        },
      ],
    });
  }
}
__decorate([
  MapToComponentField()
], VegaTableCellStateController.prototype, "host", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableCellStateController.prototype, "density", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableCellStateController.prototype, "columnDivider", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableCellStateController.prototype, "clickable", void 0);
